# Switch from CentOS to Anolis OS

This script is designed to automatically convert a CentOS instance to Anolis OS in-place.

## Supported versions

This script supports switching CentOS Linux 7 & 8. It does not support CentOS Stream.

## Before you switch

**IMPORTANT:** 
This script is not perfect and cannot handle all possible situations.
Please ensure you have a **complete backup** of the system before you execute this script.

1. Ensure your CentOS `yum` or `dnf` configuration is working, i.e. there are no
   stale repositories.
1. Ensure you have at least 5GB of free space in `/var/cache`.
1. All automatic updates, e.g. via `yum-cron` should be disabled.
1. Ensure your CentOS does not install i686 packages.

## Usage

1. Make sure you can run this script as root.
1. Make sure you have python3.
1. Either clone this repository or download [`centos2anolis.py`][2].
1. Run `python3 centos2anolis.py -v * ` to start converting.`(* is the version of the Anolis OS which you want)`

## Usage options
* `-r` Reinstalls all CentOS RPMs with Anolis OS RPMs

   If a system is swiched to Anolis OS and there is no newer Anolis OS version
   of a package already installed then the CentOS version remains.
   This option intends to reinstall any CentOS RPM with an identical version from Anolis OS.
   This is not necessary for support and has no impact to a systems functionality.
   A list of all non-Anolis OS RPMs will be displayed after the reinstall process.

* `-V` Verify RPM information before and after the switch
  This option creates four output files in `/var/tmp/`:
  * `${hostname}-rpms-list-[before|after].log`: a sorted list of installed
    packages `before` and `after` the switch to Anolis OS.
  * `${hostname}-rpms-verified-[before|after].log`: the RPM verification results
     for all installed packages `before` and `after` the switch to Anolis OS.

* `-s` Accelerate the downloading process

   The tool downloads packages from mirrors.openanolis.org by default, 
   which could take a long time. 
   This option intends to use mirrors.aliyun.com to speed up the process.
* `-v` The version of Anolis OS

   The version of Anolis OS, like `7.7` or `7.9` or `8.2` or `8.4`.If you do not specify this parameter, the system prompts you to select.

   * `Note that CentOS 7.x only supports migration to Anolis OS 7.7 or Anolis OS 7.9`.
   * `Note that CentOS 8.0-8.2 supports migration to Anolis OS 8.2 or Anolis OS 8.4`.
   * `Note that CentOS 8.3/8.4 only supports migration to Anolis OS 8.4`.

## Support
   Open an issue on [bugs.openanolis.cn][1] for any bugs, questions and requirements.

## License

Copyright (c) 2021 OpenAnolis Community.

See the LICENSE.txt file for details

[1]: https://bugs.openanolis.cn
[2]: https://gitee.com/anolis/centos2anolis/raw/master/centos2anolis.py
